## deepin-system-monitor 6.5.28

=== debian/changelog ===
deepin-system-monitor (6.5.28) unstable; urgency=medium

  * chore: Add support for Lao language translation

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 13 Aug 2025 14:32:08 +0800

deepin-system-monitor (6.5.27) unstable; urgency=medium

  * chore: Add new Lao translation file

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 07 Aug 2025 15:41:03 +0800

deepin-system-monitor (6.5.26) unstable; urgency=medium

  * feat: add average CPU frequency calculation and display.

 -- Wang Yu <wangyu@uniontch.com>  Thu, 31 Jul 2025 19:10:03 +0800

deepin-system-monitor (6.5.25) unstable; urgency=medium

  * chore: New version 6.5.25
  * fix: Corrected string formatting in system protection settings

 -- re2zero <yangwu@uniontech.com>  Thu, 31 Jul 2025 16:03:22 +0800
