=== deepin-system-monitor-main/assets/CMakeLists.txt ===
install(FILES icons/deepin/builtin/${CMAKE_PROJECT_NAME}.svg DESTINATION share/icons/hicolor/scalable/apps)
install(DIRECTORY deepin-system-monitor DESTINATION /usr/share/deepin-manual/manual-assets/application/)
