=== deepin-system-monitor-main/translations/CMakeLists.txt ===
file(GLOB APP_TS_FILES LIST_DIRECTORIES false *.ts)
if (QT_VERSION_MAJOR LESS 6)
    qt5_add_translation(APP_QM_FILES ${APP_TS_FILES})
else()
    qt6_add_translation(APP_QM_FILES ${APP_TS_FILES})
endif()
add_custom_target(QMFILES ALL DEPENDS ${APP_QM_FILES})
install(FILES ${APP_QM_FILES} DESTINATION share/${CMAKE_PROJECT_NAME}/translations)

add_subdirectory(desktop)
add_subdirectory(policy)
