=== deepin-system-monitor-plugin-popup/translations/CMakeLists.txt ===
file(GLOB APP_POPUP_TS_FILES LIST_DIRECTORIES false *.ts)
if (QT_VERSION_MAJOR LESS 6)
    qt5_add_translation(APP_POPUP_QM_FILES ${APP_POPUP_TS_FILES})
else()
    qt6_add_translation(APP_POPUP_QM_FILES ${APP_POPUP_TS_FILES})
endif()
add_custom_target(POPUP_QMFILES ALL DEPENDS ${APP_POPUP_QM_FILES})
install(FILES ${APP_POPUP_QM_FILES} DESTINATION share/${CMAKE_PROJECT_NAME}/translations)
