=== deepin-system-monitor-plugin/translations/CMakeLists.txt ===
file(GLOB APP_PLUGIN_TS_FILES LIST_DIRECTORIES false *.ts)
if (QT_VERSION_MAJOR LESS 6)
    qt5_add_translation(APP_PLUGIN_QM_FILES ${APP_PLUGIN_TS_FILES})
else()
    qt6_add_translation(APP_PLUGIN_QM_FILES ${APP_PLUGIN_TS_FILES})
endif()
add_custom_target(PLUGINQMFILES ALL DEPENDS ${APP_PLUGIN_QM_FILES})
install(FILES ${APP_PLUGIN_QM_FILES} DESTINATION share/${CMAKE_PROJECT_NAME}/translations)
