=== debian/changelog ===
deepin-system-monitor (6.5.34) unstable; urgency=medium

  * Update version to 6.5.34.
  * fix: Add XDG_DATA_HOME to XDG_DATA_DIRS

 -- re2zero <yangwu@uniontech.com>  Fri, 10 Oct 2025 14:18:19 +0800

deepin-system-monitor (6.5.33) unstable; urgency=medium

  * fix: Fix coredump issue

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 18 Sep 2025 19:36:33 +0800

deepin-system-monitor (6.5.32) unstable; urgency=medium

  * Update version to 6.5.32.
  * feat: Change the detail for CPU processor.

 -- re2zero <yangwu@uniontech.com>  Fri, 05 Sep 2025 15:25:51 +0800

deepin-system-monitor (6.5.31) unstable; urgency=medium

  * Update version to 6.5.31.

 -- re2zero <yangwu@uniontech.com>  Fri, 29 Aug 2025 11:38:09 +0800

deepin-system-monitor (6.5.30) unstable; urgency=medium

  * Update version to 6.5.30.

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 21 Aug 2025 16:57:59 +0800

deepin-system-monitor (6.5.29) unstable; urgency=medium

  * chore: Add Lao language translations in policy files

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 14 Aug 2025 16:47:11 +0800
