=== debian/control ===
Source: deepin-system-monitor
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper (>= 11), 
 cmake,
 pkg-config,
 qt6-base-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 libdtk6core-dev,
 libdtk6gui-dev,
 libdtk6widget-dev,
 libxcb1-dev,
 libxext-dev,
 libpcap-dev,
 qt6-tools-dev-tools,
 libicu-dev,
 deepin-gettext-tools,
 libxcb-util0-dev,
 libxcb-icccm4-dev,
 libnl-3-dev,
 libnl-route-3-dev,
 libudev-dev,
 dde-tray-loader-dev | dde-dock-dev,
 libgtest-dev,
 libgmock-dev,
 libpolkit-qt6-1-dev | libpolkit-qt5-1-dev
Standards-Version: 3.9.8
Homepage: https://github.com/linuxdeepin/deepin-system-monitor

Package: deepin-system-monitor
Architecture: any
Depends: ${shlibs:Depends}, 
 ${misc:Depends}, 
 libcap2-bin,
 deepin-service-manager
Recommends: uos-reporter, deepin-event-log
Replaces: deepin-system-monitor-plugin
Description: A system monitor tool.
 System Monitor is a system tool monitoring and managing hardware load, program running and system services. It's capable to real-time monitor CPU status, memory footprint, and upload/download speed, manage system and application processes, search and force end processes as well.
